Edgewall Software

This page documents the 0.12 release. Documentation for other releases can be found here.

Trac Ticket Queries

Languages:

In addition to reports, Trac provides support for custom ticket queries, used to display lists of tickets meeting a specified set of criteria.

To configure and execute a custom query, switch to the View Tickets module from the navigation bar, and select the Custom Query link.

Filters

When you first go to the query page the default filter will display tickets relevant to you:

  • If logged in then all open tickets it will display open tickets assigned to you.
  • If not logged in but you have specified a name or email address in the preferences then it will display all open tickets where your email (or name if email not defined) is in the CC list.
  • If not logged and no name/email defined in the preferences then all open issues are displayed.

Current filters can be removed by clicking the button to the left with the minus sign on the label. New filters are added from the pulldown lists at the bottom corners of the filters box ('And' conditions on the left, 'Or' conditions on the right). Filters with either a text box or a pulldown menu of options can be added multiple times to perform an or of the criteria.

You can use the fields just below the filters box to group the results based on a field, or display the full description for each ticket.

Once you've edited your filters click the Update button to refresh your results.

Clicking on one of the query results will take you to that ticket. You can navigate through the results by clicking the Next Ticket or Previous Ticket links just below the main menu bar, or click the Back to Query link to return to the query page.

You can safely edit any of the tickets and continue to navigate through the results using the Next/Previous/Back to Query links after saving your results. When you return to the query any tickets which were edited will be displayed with italicized text. If one of the tickets was edited such that it no longer matches the query criteria the text will also be greyed. Lastly, if a new ticket matching the query criteria has been created, it will be shown in bold.

The query results can be refreshed and cleared of these status indicators by clicking the Update button again.

Saving Queries

Trac allows you to save the query as a named query accessible from the reports module. To save a query ensure that you have Updated the view and then click the Save query button displayed beneath the results. You can also save references to queries in Wiki content, as described below.

Note: one way to easily build queries like the ones below, you can build and test the queries in the Custom report module and when ready - click Save query. This will build the query string for you. All you need to do is remove the extra line breaks.

Note: you must have the REPORT_CREATE permission in order to save queries to the list of default reports. The Save query button will only appear if you are logged in as a user that has been granted this permission. If your account does not have permission to create reports, you can still use the methods below to save a query.

You may want to save some queries so that you can come back to them later. You can do this by making a link to the query from any Wiki page.

[query:status=new|assigned|reopened&version=1.0 Active tickets against 1.0]

Which is displayed as:

Active tickets against 1.0

This uses a very simple query language to specify the criteria (see Query Language).

Alternatively, you can copy the query string of a query and paste that into the Wiki link, including the leading ? character:

[query:?status=new&status=assigned&status=reopened&group=owner Assigned tickets by owner]

Which is displayed as:

Assigned tickets by owner

Using the [[TicketQuery]] Macro

The TicketQuery macro lets you display lists of tickets matching certain criteria anywhere you can use WikiFormatting.

Example:

[[TicketQuery(version=0.6|0.7&resolution=duplicate)]]

This is displayed as:

#181
Wiki preview injects new lines
#204
request for colour legend (or something similar) for ticket groups in reports
#226
Ticket Dependencies
#239
Link to diff of specifik wiki change instead of the page itself
#351
All ticket modifications should be tracked in timeline
#413
Installing on Windows, drive other than C:
#450
Diffviewer should try to convert the text into utf-8.
#475
merging of similar tickets
#519
Python process sometimes hangs on Windows Server 2003
#529
IE 5-6 over HTTPS broken downloads

Just like the query: wiki links, the parameter of this macro expects a query string formatted according to the rules of the simple ticket query language. This also allows displaying the link and description of a single ticket:

[[TicketQuery(id=123)]]

This is displayed as:

#123
No SQL error display

A more compact representation without the ticket summaries is also available:

[[TicketQuery(version=0.6|0.7&resolution=duplicate, compact)]]

This is displayed as:

#181, #204, #226, #239, #351, #413, #450, #475, #519, #529

Finally, if you wish to receive only the number of defects that match the query, use the count parameter.

[[TicketQuery(version=0.6|0.7&resolution=duplicate, count)]]

This is displayed as:

10

Customizing the table format

You can also customize the columns displayed in the table format (format=table) by using col≤field> - you can specify multiple fields and what order they are displayed by placing pipes (|) between the columns like below:

[[TicketQuery(max=3,status=closed,order=id,desc=1,format=table,col=resolution|summary|owner|reporter)]]

This is displayed as:

Full rows

In table format you can also have full rows by using rows≤field> like below:

[[TicketQuery(max=3,status=closed,order=id,desc=1,format=table,col=resolution|summary|owner|reporter,rows=description)]]

This is displayed as:

Results (1 - 3 of 11143)

1 2 3 4 5 6 7 8 9 10 11
Ticket Resolution Summary Owner Reporter
#13403 fixed Trac 1.5.3 with Apache+fcgi and Python 3.8.10 doesn't work Jun Omae bobben@…
Description

Hi!

Just tried Trac 1.5.3 which is supposed to run on Python 3.5+ but I can't get it to work.

Running track-admin works fine, such as these commands:

sudo trac-admin /www/trac upgrade
sudo trac-admin /www/trac wiki upgrade
sudo trac-admin /www/trac deploy /www/trac/deploy
sudo trac-admin /www/trac repository resync '*'

But the front-end won't work.

I get this error in my Apache logs:

Content-Type: text/plain

 Oops...

Trac detected an internal error:

No module named 'dummy_thread'

Traceback (most recent call last):
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/_fcgi.py", line 53, in <module>
    import thread
ModuleNotFoundError: No module named 'thread'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Library/WebServer/CGI-Executables/trac.fcgi", line 33, in <module>
    from trac.web import fcgi_frontend
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/fcgi_frontend.py", line 51, in <module>
    from ._fcgi import WSGIServer
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/_fcgi.py", line 57, in <module>
    import dummy_thread as thread
ModuleNotFoundError: No module named 'dummy_thread'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Library/WebServer/CGI-Executables/trac.fcgi", line 47, in <module>
    tb = io.Bytes()
AttributeError: module 'io' has no attribute 'Bytes'
[Tue May 11 00:02:50.663862 2021] [:warn] [pid 11858:tid 123145536704512] mod_fcgid: error reading data, FastCGI server closed connection
[Tue May 11 00:02:50.663958 2021] [:error] [pid 11858:tid 123145536704512] End of script output before headers: trac.fcgi

So I Googled and found that you could create a thread.py file (with some content) in the site-packages directory which fixed the problem "no module named 'thread'", but then I got this error message instead:

Content-Type: text/plain

 Oops...

Trac detected an internal error:

'OSError' object is not subscriptable

Traceback (most recent call last):
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/_fcgi.py", line 987, in _setupSocket
    sock.getpeername()
OSError: [Errno 57] Socket is not connected

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Library/WebServer/CGI-Executables/trac.fcgi", line 34, in <module>
    fcgi_frontend.run()
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/fcgi_frontend.py", line 54, in run
    WSGIServer(dispatch_request, **params).run()
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/_fcgi.py", line 1064, in run
    sock = self._setupSocket()
  File "/Library/Frameworks/Python.framework/Versions/3.8/lib/python3.8/site-packages/trac/web/_fcgi.py", line 989, in _setupSocket
    if e[0] == errno.ENOTSOCK:
TypeError: 'OSError' object is not subscriptable

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/Library/WebServer/CGI-Executables/trac.fcgi", line 47, in <module>
    tb = io.Bytes()
AttributeError: module 'io' has no attribute 'Bytes'
[Mon May 10 23:18:28.531449 2021] [:warn] [pid 11858:tid 123145537777664] mod_fcgid: error reading data, FastCGI server closed connection
[Mon May 10 23:18:28.531739 2021] [:error] [pid 11858:tid 123145537777664] End of script output before headers: trac.fcgi

I am using the latest trac.fcgi from installation of Trac 1.5.3, which points to the Python 3.8 binary and the trac.fcgi file has execute permissions for the 'www' user of Apache.

Some googling suggested that the error 'End of script output' and Apache error 500 is because of insufficient execute permissions of the trac.fcgi in the cgi-bin for Apache.

Used 'r-x------' (500) for user 'www' successfully with Python 2.7 and Trac 1.4.2, but even tried 'r-x--x--x' (511) with this new version, but doesn't help.

I'm currently running Apache 2.4.46, mod_fcgid 2.3.9, subversion 1.14.1 and Python 3.8.10 on macOS 10.13.6.

Kind regards Pär

#13401 fixed crash in apr_pool_destroy when accessing non-existing file in version control browser Jun Omae rickvanderzwet@…
Description

When I run tracd and request a non-existing file from the repository, the application crashes:

Server:

$ cat <<EOF > gdbcmds.txt
set height 0
set breakpoint pending on
run  trac/web/standalone.py  -p 8000  --base-path /trac -e ~/tracenvs
backtrace
quit
EOF

PYTHONPATH=.  gdb /usr/local/bin/python3.8 -x gdbcmds.txt -batch

Client: ab -n3 http://172.26.128.54:8000/trac/bar/export/1/second.txt

Coredump (full log in attachment:typescript-coredump-backtrace.txt)

Server starting in PID 77461.
Serving on 0.0.0.0:8000 view at http://127.0.0.1:8000/trac
Using HTTP/1.1 protocol version
[New LWP 101056 of process 77461]
172.26.140.136 - - [27/Apr/2021 00:29:10] "GET /trac/bar/export/1/second.txt HTTP/1.0" 404 -
[LWP 101056 of process 77461 exited]
[New LWP 101058 of process 77461]
172.26.140.136 - - [27/Apr/2021 00:29:16] "GET /trac/bar/export/1/second.txt HTTP/1.0" 404 -
[LWP 101058 of process 77461 exited]
[New LWP 101057 of process 77461]

Thread 4 received signal SIGSEGV, Segmentation fault.
[Switching to LWP 101057 of process 77461]
0x00000008043b6478 in run_cleanups (cref=<error reading variable: Cannot access memory at address 0x7fffdf3fbff8>) at memory/unix/apr_pools.c:2624
2624    {
#0  0x00000008043b6478 in run_cleanups (cref=<error reading variable: Cannot access memory at address 0x7fffdf3fbff8>) at memory/unix/apr_pools.c:2624
#1  0x00000008043b5e6e in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:987
#2  0x00000008043b5ea8 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:997
#3  0x00000008043b5ea8 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:997
#4  0x00000008043b5ea8 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:997
#5  0x00000008043b5ea8 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:997
#6  0x00000008043b5ea8 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:99

If I compile apr with --enable-pool-concurrency-check the following error is shown when I request the URL (first hit) (full log in attachment:typescript-with-apr-pool-concurrenty-check.txt]:

Server starting in PID 58551.
Serving on 0.0.0.0:8000 view at http://127.0.0.1:8000/trac
Using HTTP/1.1 protocol version
[New LWP 100421 of process 58551]
172.26.140.136 - - [27/Apr/2021 00:26:51] "GET /trac/bar/export/1/second.txt HTTP/1.0" 404 -
pool concurrency check: pool 0x8044f5028((null)), thread cur 802d09c00 in use by 802d09c00, state destroyed -> in use 

Thread 2 received signal SIGABRT, Aborted.
[Switching to LWP 100421 of process 58551]
0x00000008008d5c2a in thr_kill () from /lib/libc.so.7
#0  0x00000008008d5c2a in thr_kill () from /lib/libc.so.7
#1  0x00000008008d4084 in raise () from /lib/libc.so.7
#2  0x000000080084a279 in abort () from /lib/libc.so.7
#3  0x00000008043b7cb1 in pool_concurrency_abort (pool=0x8044f5028, new=1, old=2) at memory/unix/apr_pools.c:768
#4  0x00000008043b6433 in pool_concurrency_set_used (pool=0x8044f5028) at memory/unix/apr_pools.c:778
#5  0x00000008043b5fb7 in apr_pool_destroy (pool=0x8044f5028) at memory/unix/apr_pools.c:989
#6  0x0000000804619097 in _wrap_apr_pool_destroy (self=<module at remote 0x805449b30>, args=(<apr_pool_t(this=<SwigPyObject at remote 0x80388a210>, _parent_pool=<apr_pool_t(this=<SwigPyObject at remote 0x80388a540>, _weakparent=<weakref at remote 0x803884680>, _apr_pool_destroy=<built-in method apr_pool_destroy of module object at remote 0x805449b30>, _svn_swig_py_clear_application_pool=<built-in method svn_swig_py_clear_application_pool of module object at remote 0x805449b30>) at remote 0x80388a3d0>, _weakparent=<weakref at remote 0x805437680>, _is_valid=<function at remote 0x804b6adc0>, _apr_pool_destroy=<built-in method apr_pool_destroy of module object at remote 0x805449b30>, _svn_swig_py_clear_application_pool=<built-in method svn_swig_py_clear_application_pool of module object at remote 0x805449b30>) at remote 0x80564faf0>,)) at subversion/bindings/swig/python/core.c:4034
...

I was able to find a work-around to prevent it from happening, how-ever I do not know why this actually fixes it and whether this is the correct place to fix it:

Index: tracopt/versioncontrol/svn/svn_fs.py
===================================================================
--- tracopt/versioncontrol/svn/svn_fs.py	(revision 17527)
+++ tracopt/versioncontrol/svn/svn_fs.py	(working copy)
@@ -686,6 +686,7 @@
                 raise NoSuchNode(path, rev, exception_to_unicode(e)) from e
         node_type = fs.check_path(self.root, self._scoped_path_utf8, pool)
         if node_type not in _kindmap:
+            pool.destroy()
             raise NoSuchNode(path, rev)
         cp_utf8 = fs.node_created_path(self.root, self._scoped_path_utf8, pool)
         cp = _from_svn(cp_utf8)

Version information of my development system:

$ svn --version
svn, version 1.14.1 (r1886195)
   compiled Apr 21 2021, 12:19:02 on amd64-portbld-freebsd12.2

$ python --version
Python 3.8.9

$ pkg info | grep -e apr -e serf -e subversion -e python
apr-1.7.0.1.6.1_1              Apache Portability Library
py38-subversion-1.14.1_2       Python bindings for version control system
python-3.8_3,2                 "meta-port" for the default version of Python interpreter
python3-3_3                    The "meta-port" for version 3 of the Python interpreter
python38-3.8.9                 Interpreted object-oriented programming language
serf-1.3.9_6                   Serf HTTP client library
subversion-1.14.1              Version control system

$ uname -a
FreeBSD hbsd122 12.2-RELEASE FreeBSD 12.2-RELEASE r366954 GENERIC  amd64
#13391 cantfix AttributeError: 'bytes' object has no attribute 'encode' anonymous
Description

How to Reproduce

While doing a GET operation on /prefs/localization, Trac issued an internal error.

The issue in ticket:13378 is related to the problem reported here. I am reporting this issue since there might be more similar issues related to porting to python3.

Request parameters:

{'panel_id': 'localization'}

User agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:78.0) Gecko/20100101 Firefox/78.0

System Information

Trac 1.5.2
Babel 2.5.1
Docutils 0.14
Jinja2 2.11.3
mod_wsgi 4.6.4 (WSGIProcessGroup WSGIApplicationGroup %{GLOBAL})
PostgreSQL server: 10.15, client: 12.4
psycopg2 2.7.5 (dt dec pq3 ext lo64)
Pygments 2.2.0
Python 3.6.8 (default, Aug 24 2020, 17:57:11)
[GCC 8.3.1 20191121 (Red Hat 8.3.1-5)]
pytz 2017.2
setuptools 39.2.0
Subversion 1.14.1 (r1886195)
jQuery 1.12.4
jQuery UI 1.12.1
jQuery Timepicker 1.6.3

Enabled Plugins

Interface Customization

Python Traceback

Traceback (most recent call last):
  File "/usr/local/lib/python3.6/site-packages/trac/web/main.py", line 609, in dispatch_request
    dispatcher.dispatch(req)
  File "/usr/local/lib/python3.6/site-packages/trac/web/main.py", line 301, in dispatch
    raise e
  File "/usr/local/lib/python3.6/site-packages/trac/web/main.py", line 248, in dispatch
    resp = chosen_handler.process_request(req)
  File "/usr/local/lib/python3.6/site-packages/trac/prefs/web_ui.py", line 108, in process_request
    resp = chosen_provider.render_preference_panel(req, panel_id)
  File "/usr/local/lib/python3.6/site-packages/trac/prefs/web_ui.py", line 219, in render_preference_panel
    default_timezone = get_timezone(default_timezone_id) or localtz
  File "/usr/local/lib/python3.6/site-packages/trac/util/datefmt.py", line 1177, in get_timezone
    tz = pytz.timezone(to_unicode(tzname).encode('ascii', 'replace'))
  File "/usr/lib/python3.6/site-packages/pytz/__init__.py", line 158, in timezone
    zone = ascii(zone)
  File "/usr/lib/python3.6/site-packages/pytz/__init__.py", line 55, in ascii
    s.encode('ASCII') # Raise an exception if not ASCII
AttributeError: 'bytes' object has no attribute 'encode'
1 2 3 4 5 6 7 8 9 10 11

Query Language

query: TracLinks and the [[TicketQuery]] macro both use a mini “query language” for specifying query filters. Basically, the filters are separated by ampersands (&). Each filter then consists of the ticket field name, an operator, and one or more values. More than one value are separated by a pipe (|), meaning that the filter matches any of the values. To include a literal & or | in a value, escape the character with a backslash (\).

The available operators are:

= the field content exactly matches one of the values
~= the field content contains one or more of the values
^= the field content starts with one of the values
$= the field content ends with one of the values

All of these operators can also be negated:

!= the field content matches none of the values
!~= the field content does not contain any of the values
!^= the field content does not start with any of the values
!$= the field content does not end with any of the values

The date fields created and modified can be constrained by using the = operator and specifying a value containing two dates separated by two dots (..). Either end of the date range can be left empty, meaning that the corresponding end of the range is open. The date parser understands a few natural date specifications like "3 weeks ago", "last month" and "now", as well as Bugzilla-style date specifications like "1d", "2w", "3m" or "4y" for 1 day, 2 weeks, 3 months and 4 years, respectively. Spaces in date specifications can be left out to avoid having to quote the query string.

created=2007-01-01..2008-01-01 query tickets created in 2007
created=lastmonth..thismonth query tickets created during the previous month
modified=1weekago.. query tickets that have been modified in the last week
modified=..30daysago query tickets that have been inactive for the last 30 days

See also: TracTickets, TracReports, TracGuide

Last modified 7 years ago Last modified on Nov 3, 2014, 3:40:46 AM
Note: See TracWiki for help on using the wiki.